#include "StdAfx.h"
#include "NiuniuRemoteWrapper.h"
#include "Utility.h"
#pragma warning(disable:4482)


#define REMOTE_ENGINE_DLL_NAME _T("RemoteEngine.dll")

HMODULE				NiuniuRemoteWrapper::m_hModule = NULL;

FnInitEngine		NiuniuRemoteWrapper::s_InitEngine = NULL;
FnInitRemoteInfo	NiuniuRemoteWrapper::s_InitRemoteInfo = NULL;
FnSetProxy			NiuniuRemoteWrapper::s_SetProxy = NULL;
FnStartRemote		NiuniuRemoteWrapper::s_StartRemote = NULL;
FnStopRemote		NiuniuRemoteWrapper::s_StopRemote = NULL;
FnSetParam			NiuniuRemoteWrapper::s_SetParam = NULL;
FnGetStatus			NiuniuRemoteWrapper::s_GetStatus = NULL;
FnDisConnect		NiuniuRemoteWrapper::s_DisConnect = NULL;
NiuniuRemoteWrapper::NiuniuRemoteWrapper(void)
{
	
}

NiuniuRemoteWrapper::~NiuniuRemoteWrapper(void)
{
}





void NiuniuRemoteWrapper::Init()
{
	wstring strDllPath = GetCurrentPathW() + REMOTE_ENGINE_DLL_NAME;
	m_hModule = LoadLibraryW(strDllPath.c_str());
	DWORD dRet = GetLastError();
	s_InitEngine = (FnInitEngine)GetProcAddress(m_hModule, "InitEngine");
	s_InitRemoteInfo = (FnInitRemoteInfo)GetProcAddress(m_hModule, "InitRemoteInfo");	
	s_SetProxy = (FnSetProxy)GetProcAddress(m_hModule, "SetProxy");	
	s_StartRemote = (FnStartRemote)GetProcAddress(m_hModule, "StartRemote");
	s_StopRemote = (FnStopRemote)GetProcAddress(m_hModule, "StopRemote");
	s_SetParam = (FnSetParam)GetProcAddress(m_hModule, "SetParam");
	s_GetStatus = (FnGetStatus)GetProcAddress(m_hModule, "GetStatus");
	s_DisConnect = (FnDisConnect)GetProcAddress(m_hModule, "DisConnect");

}

int NiuniuRemoteWrapper::InitEngine(const wchar_t* authKey)
{
	return s_InitEngine(authKey);
}

int NiuniuRemoteWrapper::InitRemoteInfo(const wchar_t* identifier, const int asDriver, const wchar_t* serverAddr, const int serverPort, void* pFuncNotice, void* pObjPoint)
{
	return s_InitRemoteInfo(identifier, asDriver, serverAddr, serverPort, pFuncNotice, pObjPoint);
}

int NiuniuRemoteWrapper::SetProxy(const int proxyType, const wchar_t* proxyServer, const int proxyPort, const wchar_t* proxyUser, const wchar_t* proxyPwd, const wchar_t* proxyDomain)
{
	return s_SetProxy(proxyType, proxyServer, proxyPort, proxyUser, proxyPwd, proxyDomain);
}

int NiuniuRemoteWrapper::StartRemote(const wchar_t* identifier, int isViewer, int isControl, int quality, const wchar_t* myName, const wchar_t* peerName)
{
	return s_StartRemote(identifier, isViewer, isControl, quality, myName, peerName);
}

int NiuniuRemoteWrapper::StopRemote(const wchar_t* identifier)
{
	return s_StopRemote(identifier);
}

int NiuniuRemoteWrapper::SetParam(const wchar_t* identifier, const int paramFlag, UINT_PTR paramValue)
{
	return s_SetParam(identifier, paramFlag, paramValue);
}

int NiuniuRemoteWrapper::GetStatus(const wchar_t* identifier)
{
	return s_GetStatus(identifier);
}

int NiuniuRemoteWrapper::DisConnect(const wchar_t* identifier)
{
	return s_DisConnect(identifier);
}


